//+------------------------------------------------------------------+
//|                                                       Expert.mq4 |
//|                                         Copyright  2005, AlexWM |
//|                                                   alexwm@ukr.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, AlexWM"
#property link      "alexwm@ukr.net"

extern double Lots = 0.1;
extern int Delta = 15;
extern int NetProfit = 15;

int cnt=0, Ticket=0, TotalOrders=0, Points=0;
int BuyStopOrders=0, SellStopOrders=0, BuyOrders=0, SellOrders=0, NeedOrder=0;
int CloseAll=0;
double PriceFirstBuy=0, PriceFirstSell=0, AktivPrice=0, AktivPriceSellStop=0, AktivPriceBuyStop=0;
double Profit=0, TotalProfit=0, Swap=0; 

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  
//----
Points = MarketInfo (Symbol(), MODE_POINT);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
TotalOrders=OrdersTotal();

//       =================================

if (CloseAll==1)
   {
   for(cnt=0;cnt<TotalOrders;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol()) {OrderDelete(OrderTicket()); return(0);}
      if (OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol()) {OrderDelete(OrderTicket()); return(0);}
      if (OrderType()==OP_BUY && OrderSymbol()==Symbol()) {OrderClose(OrderTicket(),Lots,Bid,3,Yellow); return(0);}
      if (OrderType()==OP_SELL && OrderSymbol()==Symbol()) {OrderClose(OrderTicket(),Lots,Ask,3,Yellow); return(0);}
      }
   }

//   ==========================================================

if (TotalOrders==0)
   {
   CloseAll=0; //    
   PriceFirstBuy=Ask+Delta*Point; 
   Ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,PriceFirstBuy,3,0,0,"FirstBuy",16384,0,Blue);
   if (Ticket<0)
       {
        Print("BuyStop    #",GetLastError());
        return(0);
       }
   GlobalVariableSet("NextBuyStopPrice",PriceFirstBuy);    
   return(0);    
   } 
   
if (TotalOrders==1) 
   {
   for(cnt=0;cnt<TotalOrders;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      //========  
      if (OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol())
         {     
         PriceFirstSell=Bid-Delta*Point;  
         Ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,PriceFirstSell,3,0,0,"FirstSell",16384,0,Red);
         if (Ticket<0)
            {
            Print("SellStop    #",GetLastError());
            return(0);
            }
      GlobalVariableSet("NextSellStopPrice",PriceFirstSell);      
      return(0);
         }
      //========
      if (OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol())
         { 
         PriceFirstBuy=Ask+Delta*Point; 
         Ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,PriceFirstBuy,3,0,0,"FirstBuy",16384,0,Blue);
         if (Ticket<0)
            {
            Print("BuyStop    #",GetLastError());
            return(0);
            }
      GlobalVariableSet("NextBuyStopPrice",PriceFirstBuy);       
      return(0);
         }        
            
      }   
   }

//  - =================================================================================
   
if (TotalOrders>1 && NeedOrder!=0)
   {
   if (NeedOrder==1) //  -
      {
      AktivPrice=GlobalVariableGet("NextBuyStopPrice");
      AktivPriceBuyStop=AktivPrice+Delta*Point; 
         Ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,AktivPriceBuyStop,3,0,0,"Buy",16384,0,Blue);
         if (Ticket<0)
            {
            Print("BuyStop    #",GetLastError());
            return(0);
            }
      NeedOrder=0; // 
      GlobalVariableSet("NextBuyStopPrice",AktivPriceBuyStop);     
      return(0);
      }
   if (NeedOrder==2) //  -
      { 
      AktivPrice=GlobalVariableGet("NextSellStopPrice");
      AktivPriceSellStop=AktivPrice-Delta*Point;  
         Ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,AktivPriceSellStop,3,0,0,"Sell",16384,0,Red);
         if (Ticket<0)
            {
            Print("SellStop    #",GetLastError());
            return(0);
            }
      NeedOrder=0; // 
      GlobalVariableSet("NextSellStopPrice",AktivPriceSellStop);            
      return(0);
      }  
   } 

//   =======================================================================================
   
if (TotalOrders>1)
   {
   BuyStopOrders=0; SellStopOrders=0; BuyOrders=0; SellOrders=0; 
   TotalProfit=0; Profit=0;
   for(cnt=0;cnt<TotalOrders;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol()) BuyStopOrders++;
      if (OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol()) SellStopOrders++;
      if (OrderType()==OP_BUY && OrderSymbol()==Symbol()) BuyOrders++;
      if (OrderType()==OP_SELL && OrderSymbol()==Symbol()) SellOrders++;
      
      //  
      Profit=OrderProfit();
      Swap=OrderSwap();
      TotalProfit=TotalProfit+Profit+Swap;
      }
      Comment("Total Profit: ",TotalProfit,"\n","Buy: ",BuyOrders,"\n","Sell: ",SellOrders);
      
      ObjectsRedraw();
      
      if (TotalProfit>NetProfit) CloseAll=1; //   -       
      
// -      ------------------------------------------------      

      if (BuyStopOrders==0) // -
         {
         for(cnt=0;cnt<TotalOrders;cnt++)
            {  
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if (OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol()) 
               {
               AktivPrice=GlobalVariableGet("NextBuyStopPrice");
               AktivPriceSellStop=AktivPrice-Delta*Point+(Ask-Bid); 
               if (OrderModify(OrderTicket(),AktivPriceSellStop,0,0,0,Violet)) {NeedOrder=1; GlobalVariableSet("NextSellStopPrice",AktivPriceSellStop);} //  -
               return(0);
               }
            }  
         }
      if (SellStopOrders==0) // -
         {
         for(cnt=0;cnt<TotalOrders;cnt++)
            {  
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if (OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol()) 
               {
               AktivPrice=GlobalVariableGet("NextSellStopPrice");
               AktivPriceBuyStop=AktivPrice+Delta*Point-(Ask-Bid);
               if (OrderModify(OrderTicket(),AktivPriceBuyStop,0,0,0,Magenta)) {NeedOrder=2; GlobalVariableSet("NextBuyStopPrice",AktivPriceBuyStop);} //  -
               return(0);
               }
            }  
         }   
   }    
 
               
     
//----
   return(0);
  }

//+------------------------------------------------------------------+